function [a]=GenesWorks(handles)
%% input data 


%initial conditions [x1(0) x2(0) x3(0) x4(0) x5(0)]
x1_= str2double(get(handles.edit1,'String'));
x2_= str2double(get(handles.edit2,'String'));
x3_= str2double(get(handles.edit3,'String'));
x4_= str2double(get(handles.edit4,'String'));
x5_= str2double(get(handles.edit5,'String'));
x0=[x1_ x2_ x3_ x4_ x5_];
x1(1)=x0(1);
x2(1)=x0(2);
x3(1)=x0(3);
x4(1)=x0(4);
x5(1)=x0(5);

%semipopulation size
N=x1(1)+x2(1);

%fitness factors
w1= str2double(get(handles.edit6,'String'));
w2= str2double(get(handles.edit7,'String'));
w3= str2double(get(handles.edit8,'String'));
w4= str2double(get(handles.edit9,'String'));
w5= str2double(get(handles.edit10,'String'));

%number of generations 
T_sim=str2double(get(handles.edit11,'String'));

%spontaneous mutation rates
gamma=str2double(get(handles.edit12,'String'));
mu=str2double(get(handles.edit13,'String'));

%% Example: data for Application 1 (Color blindness)

% N=87252/2;
% x0=[43000  N-43000  40000 2000 N-42000];
% 
% x1(1)=x0(1);
% x2(1)=x0(2);
% x3(1)=x0(3);
% x4(1)=x0(4);
% x5(1)=x0(5);
% 
% w1=1;
% w2=1;
% w3=1;
% w4=1;
% w5=1;
% 
% gamma=2*10^-5;
% mu=gamma;
%%

xm(1)=x1(1)+x2(1);                   %male population size
xf(1)=x3(1)+x4(1)+x5(1);             %female population size
pf(1)=(w3*x3(1)+w4*0.5*x0(4))/xf(1); %allele A's frequency in females
qf(1)=(w5*x5(1)+w4*0.5*x0(4))/xf(1); %allele a's frequency in females
pm(1)=(w1*x1(1))/xm(1);              %allele A's frequency in males
qm(1)=(w2*x2(1))/xm(1);              %allele a's frequency in males
uf(1)=pf(1)/qf(1);                   %female gene ratio         
um(1)=pm(1)/qm(1);                   %male gene ratio

for k=1:T_sim
  
    P(k)=(x1(k)+x2(k)+x3(k)+x4(k)+x5(k))/(2*(x1(k)+x2(k))*(x3(k)+x4(k)+x5(k)));

    x1(k+1)=P(k)*(w1*w3*(1-gamma)*x1(k)*x3(k)+w2*w3*(1-gamma)*x2(k)*x3(k)+1/2*w1*w4*(1-gamma+mu)*x1(k)*x4(k)+1/2*w2*w4*(1-gamma+mu)*x2(k)*x4(k)+mu*w1*w5*x1(k)*x5(k)+mu*w2*w5*x2(k)*x5(k));  
    x2(k+1)=P(k)*(w1*w3*gamma*x1(k)*x3(k)+1/2*w1*w4*(1+gamma-mu)*x1(k)*x4(k)+1/2*w2*w4*(1+gamma-mu)*x2(k)*x4(k)+ w2*w3*gamma*x2(k)*x3(k)+w1*w5*(1-mu)*x1(k)*x5(k)+w2*w5*(1-mu)*x2(k)*x5(k));   
    x3(k+1)=P(k)*(w1*w3*(1-gamma)^2*x1(k)*x3(k)+1/2*w1*w4*(1-gamma)*(1-gamma+mu)*x1(k)*x4(k)+mu*(1-gamma)*w1*w5*x1(k)*x5(k)+mu*(1-gamma)*w2*w3*x2(k)*x3(k)+mu/2*(1-gamma+mu)*w2*w4*x2(k)*x4(k)+mu^2*w2*w5*x2(k)*x5(k));    
    x4(k+1)= P(k)*(2*w1*w3*gamma*(1-gamma)*x1(k)*x3(k)+w1*w4*(1/2*(1+gamma-mu)+gamma*(mu-gamma))*x1(k)*x4(k)+w2*w3*((1-gamma)*(1-mu)+mu*gamma)*x2(k)*x3(k)+w2*w4*(1/2*(1-gamma+mu)+mu*(gamma-mu))*x2(k)*x4(k)+w1*w5*((1-gamma)*(1-mu)+gamma*mu)*x1(k)*x5(k)+2*mu*(1-mu)*w2*w5*x2(k)*x5(k));   
    x5(k+1)= P(k)*(w1*w3*gamma^2*x1(k)*x3(k)+1/2*w1*w4*gamma*(1+gamma-mu)*x1(k)*x4(k)+w2*w3*gamma*(1-mu)*x2(k)*x3(k)+1/2*w2*w4*(1+gamma-mu)*(1-mu)*x2(k)*x4(k)+w1*w5*gamma*(1-mu)*x1(k)*x5(k)+w2*w5*(1-mu)^2*x2(k)*x5(k));   

    xm(k+1)=x1(k+1)+x2(k+1);
    xf(k+1)=x3(k+1)+x4(k+1)+x5(k+1);
    pf(k+1)=(w3*x3(k+1)+w4*0.5*x4(k+1))/xf(k+1);
    qf(k+1)=(w5*x5(k+1)+w4*0.5*x4(k+1))/xf(k+1);
    pm(k+1)=w1*x1(k+1)/xm(k+1);
    qm(k+1)=w2*x2(k+1)/xm(k+1);
    uf(k+1)=pf(k+1)/qf(k+1);
    um(k+1)=pm(k+1)/qm(k+1);

end

%%

k=1:T_sim+1;

figure(1)
plot(x1,'LineWidth',2); hold on;plot(x2,'r','LineWidth',2); hold on;plot(x3,'g','LineWidth',2); hold on;plot(x4,'m','LineWidth',2); hold on;plot(x5,'k','LineWidth',2); legend('x1','x2','x3','x4','x5');hold off;figure(gcf);
axis([0 T_sim+1 0 4.5*10^4])
title('Number of individuals')
grid on
xlabel('Time [generations]','FontSize',12)

figure(2)
plot(k,pf); hold all;plot(k,qf);legend('pf','qf');title('females genotype frequencies'),hold off

figure(3)
plot(k,pm); hold all;plot(k,qm);legend('pm','qm');title('males genotype frequencies'),hold off

% figure(4)
% plot(uf); hold on;plot(um,'r');legend('uf','um');hold off

%%
f1 = fopen('simulation_results.txt','w');
fprintf(f1,'%s\n','#########OUTPUT#########');
fprintf(f1,'%s\n','x1');
fprintf(f1,'%.2f ',x1);
fprintf(f1,'%s\n',' ');
fprintf(f1,'%s\n','x2');
fprintf(f1,'%.2f ',x2);
fprintf(f1,'%s\n',' ');
fprintf(f1,'%s\n','x3');
fprintf(f1,'%.2f ',x3);
fprintf(f1,'%s\n',' ');
fprintf(f1,'%s\n','x4');
fprintf(f1,'%.2f ',x4);
fprintf(f1,'%s\n',' ');
fprintf(f1,'%s\n','x5');
fprintf(f1,'%.2f ',x5);
fprintf(f1,'%s\n',' ');
fprintf(f1,'%s\n','females genotype frequencies: pf');
fprintf(f1,'%.2f ',pf);
fprintf(f1,'%s\n',' ');
fprintf(f1,'%s\n','females genotype frequencies: qf');
fprintf(f1,'%.2f ',qf);
fprintf(f1,'%s\n',' ');
fprintf(f1,'%s\n','males genotype frequencies: pm');
fprintf(f1,'%.2f ',pm);
fprintf(f1,'%s\n',' ');
fprintf(f1,'%s\n','males genotype frequencies: qm');
fprintf(f1,'%.2f ',qm);
fprintf(f1,'%s\n',' ');
fclose(f1);

end